export var LOGIN_REQUEST = 'LOGIN_REQUEST';
export var LOGIN_SUCCESS = 'LOGIN_SUCCESS';
export var LOGIN_FAILURE = 'LOGIN_FAILURE';

export var LOGOUT = 'LOGOUT';
export var LOGOUT_SUCCESS = 'LOGOUT_SUCCESS';
export var LOGOUT_FAILURE = 'LOGOUT_FAILURE';

export var login = function login(config) {
  return {
    type: LOGIN_REQUEST,
    config: config
  };
};

export var loginSuccess = function loginSuccess(token, expiresAt) {
  return {
    type: LOGIN_SUCCESS,
    token: token,
    expiresAt: expiresAt
  };
};

export var loginFailure = function loginFailure(error) {
  return {
    type: LOGIN_FAILURE,
    error: error
  };
};

export var logout = function logout() {
  return {
    type: LOGOUT
  };
};

export var logoutSuccess = function logoutSuccess() {
  return {
    type: LOGOUT_SUCCESS
  };
};

export var logoutFailure = function logoutFailure(error) {
  return {
    type: LOGOUT_FAILURE,
    error: error
  };
};