'use strict';

exports.__esModule = true;
var LOGIN_REQUEST = exports.LOGIN_REQUEST = 'LOGIN_REQUEST';
var LOGIN_SUCCESS = exports.LOGIN_SUCCESS = 'LOGIN_SUCCESS';
var LOGIN_FAILURE = exports.LOGIN_FAILURE = 'LOGIN_FAILURE';

var LOGOUT = exports.LOGOUT = 'LOGOUT';
var LOGOUT_SUCCESS = exports.LOGOUT_SUCCESS = 'LOGOUT_SUCCESS';
var LOGOUT_FAILURE = exports.LOGOUT_FAILURE = 'LOGOUT_FAILURE';

var login = exports.login = function login(config) {
  return {
    type: LOGIN_REQUEST,
    config: config
  };
};

var loginSuccess = exports.loginSuccess = function loginSuccess(token, expiresAt) {
  return {
    type: LOGIN_SUCCESS,
    token: token,
    expiresAt: expiresAt
  };
};

var loginFailure = exports.loginFailure = function loginFailure(error) {
  return {
    type: LOGIN_FAILURE,
    error: error
  };
};

var logout = exports.logout = function logout() {
  return {
    type: LOGOUT
  };
};

var logoutSuccess = exports.logoutSuccess = function logoutSuccess() {
  return {
    type: LOGOUT_SUCCESS
  };
};

var logoutFailure = exports.logoutFailure = function logoutFailure(error) {
  return {
    type: LOGOUT_FAILURE,
    error: error
  };
};