'use strict';

exports.__esModule = true;

var _token = require('./util/token');

var _oauth = require('./oauth2');

var _oauth2 = _interopRequireDefault(_oauth);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import { setToken, removeToken } from './util/token'
var authMiddleware = function authMiddleware(store) {
  return function (next) {
    return function (action) {
      switch (action.type) {
        case _actions.LOGIN_REQUEST:
          return (0, _oauth2.default)(action.config).then(function (_ref) {
            var token = _ref.token,
                expiresAt = _ref.expiresAt;
            return store.dispatch((0, _actions.loginSuccess)(token, expiresAt));
          }, function (error) {
            return store.dispatch((0, _actions.loginFailure)(error));
          });
        case _actions.LOGIN_SUCCESS:
          (0, _token.setTokenx)();
          //setToken(action.token, action.expiresAt)
          break;
        case _actions.LOGIN_FAILURE:
          break;
        case _actions.LOGOUT:
          return (0, _oauth.unauthorize)().then(function () {
            return store.dispatch((0, _actions.logoutSuccess)());
          }, function (error) {
            return store.dispatch((0, _actions.logoutFailure)(error));
          });

        case _actions.LOGOUT_SUCCESS:
          //removeToken()
          (0, _token.removeTokenx)();
          break;
        case _actions.LOGOUT_FAILURE:
          break;
        /*
        case LOGOUT:
          removeToken()
          break**/
        default:
          return next(action);

      }

      return next(action);
    };
  };
};

exports.default = authMiddleware;
module.exports = exports['default'];