'use strict';

exports.__esModule = true;

var _token = require('./util/token');

var _actions = require('./actions');

/*
const initialState = {
  isLoggedIn: hasToken(),
  token: getToken(),
  expiresAt: getExpiresAt(),
  isLoggingIn: false,
  error: null
}*/
var initialState = {
  isLoggedIn: (0, _token.hasTokenize)(),
  token: null,
  expiresAt: null,
  isLoggingIn: false,
  error: null
}; //import { hasToken, getToken, getExpiresAt } from './util/token'


var auth = function auth() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case _actions.LOGIN_REQUEST:
      return Object.assign({}, state, {
        isLoggingIn: true
      });
    case _actions.LOGIN_SUCCESS:
      return Object.assign({}, state, {
        isLoggedIn: true,
        token: action.token,
        expiresAt: action.expiresAt,
        error: null,
        isLoggingIn: false
      });
    case _actions.LOGIN_FAILURE:
      return Object.assign({}, state, {
        isLoggedIn: false,
        token: null,
        expiresAt: null,
        error: action.error,
        isLoggingIn: false
      });
    case _actions.LOGOUT:
      return Object.assign({}, state, {
        isLoggedIn: false
      });

    case _actions.LOGOUT_SUCCESS:
      return Object.assign({}, state, {
        isLoggedIn: false,
        token: null,
        expiresAt: null,
        error: null,
        isLoggingIn: false
      });
    case _actions.LOGOUT_FAILURE:
      return Object.assign({}, state, {
        isLoggedIn: false,
        token: null,
        expiresAt: null,
        error: action.error,
        isLoggingIn: false
      });

    default:
      return state;
  }
};

exports.default = auth;
module.exports = exports['default'];